#include <curses.h>

#ifdef NOPANEL
#include <nopanel.h>
#else
#include <panel.h>
#endif

#include <string.h>
#include "resource.h"

void fppmovie(void);

void games (void)
{
  int res;

  res = DoSbox ("Spielen");

  switch (res) {
  case 300:
    Sweep ();
    break;
  case 301:
    HangMan ();
    break;
  }
}

void itsanfpp(void)
{
  WINDOW *win, *sub;
  PANEL  *pan, *spa;

  if ((win = newwin (24, 78, (LINES-24)/12, (COLS-78)/2)) == NULL)
    return;
  if ((sub = subwin (win, 22, 74, (LINES-22)/2, (COLS-74)/2)) == NULL) {
    delwin (win);
    return;
  }
  if ((pan = new_panel (win)) == NULL) {
    delwin (sub);
    delwin (win);
    return;
  }
  if ((spa = new_panel (sub)) == NULL) {
    del_panel (pan);
    delwin (sub);
    delwin (win);
    return;
  }
  
  wattrset  (win, COLOR_PAIR (3));
  wattrset  (sub, COLOR_PAIR (3));
  wfill     (win);
  wfill     (sub);
  box       (win, 0, 0);

  wattrset  (sub, COLOR_PAIR (4));
  woutline  (sub, "--- F r a n k   P i l h o f e r ---", 0, AL_CENTER);

  wattrset  (sub, COLOR_PAIR (2));
  woutline  (sub, "   I t ' s    a n    ",  2, AL_CENTER);
  wattrset  (sub, COLOR_PAIR (5));
  woutline  (sub, "*******      ******  ",  3, AL_CENTER);
  woutline  (sub, "**           **   ** ",  4, AL_CENTER);
  woutline  (sub, "**           **   ** ",  5, AL_CENTER);
  woutline  (sub, "******       ******  ",  6, AL_CENTER);
  woutline  (sub, "**           **      ",  7, AL_CENTER);
  woutline  (sub, "**  ******   **      ",  8, AL_CENTER);
  woutline  (sub, "**  **   **  **      ",  9, AL_CENTER);
  woutline  (sub, "    **   **          ", 10, AL_CENTER);
  woutline  (sub, "    ******           ", 11, AL_CENTER);
  woutline  (sub, "    **               ", 12, AL_CENTER);
  woutline  (sub, "    **  roject       ", 13, AL_CENTER);
  woutline  (sub, "    **               ", 14, AL_CENTER);

  wattrset  (sub, COLOR_PAIR (3));
  woutline  (sub, "Frank Pilhofer",        10, AL_LEFT);
  woutline  (sub, "Darmstaedter Str. 22",  11, AL_LEFT);
  woutline  (sub, "63225 Langen",          12, AL_LEFT);
  woutline  (sub, "Tel: 06103/51973",      13, AL_LEFT);
  woutline  (sub, "DxJ: 06103-51973-1",    14, AL_LEFT); 

  wattrset  (sub, COLOR_PAIR (4));
  woutline  (sub, "Liebe Gruesse und beste Wuensche an", 16, AL_CENTER);
  wattrset  (sub, COLOR_PAIR (2));
  woutline  (sub, " ... ", 17, AL_CENTER);

  wattrset  (sub, COLOR_PAIR (4));
  woutline  (sub, "Weiterin gegruesst seien", 19, AL_CENTER);
  wattrset  (sub, COLOR_PAIR (2));
  woutline  (sub, "* Mary * Andreas * Dirk * Dirk * Sabine * Martin *", 20, AL_CENTER);

  wattrset  (sub, COLOR_PAIR (3));
  woutline  (sub, "Und ein grosses Hallo an alle, die mich kennen und moegen",
	     22, AL_RIGHT);

  DelKeyHook     (CTRL('P'));
  SetKeyHook     (CTRL('P'), games);

  SetHelpContext ("HerzlichenGlueckwunsch");
  SetKeyHook     (KEY_F(8),  fppmovie);
  SetKeyHook     (CTRL('X'), fppmovie);
  InputChar      ();
  DelKeyHook     (CTRL('X'));
  DelKeyHook     (KEY_F(8));
  DelHelpContext ();

  del_panel (pan);
  del_panel (spa);
  delwin    (win);
  delwin    (sub);
}

void fppmovie (void)
{
  static char *l[] = {
    "                                         ****    ***                                                                                                                                                                                                                                                                                            ",
    "                                         *       *  *          *******   ********   **     **  *******   ******    ******   ********             ******   **    **  **    **   ******             **     **  **    **  ******                  *******   *******  **       ********                                                             ",
    "                                         ****    ***          **         **     **  **     **  **       **    **  **    **     **               **    **  ***   **  ***   **  **    **            **     **  ***   **  **   **                **         **       **          **                                                                ",
    "                                         *       *            **         **     **  **     **  **       **        **           **               **    **  ****  **  ****  **  **    **            **     **  ****  **  **    **               **         **       **          **                                                                ",
    "                                         *  ***  *            **   ****  ********   **     **  ******    ******    ******      **               ********  ** ** **  ** ** **  ********            **     **  ** ** **  **    **               **   ***   ******   **          **                                                                ",
    "                                            *  *              **     **  **   **    **     **  **             **        **     **               **    **  **  ****  **  ****  **    **            **     **  **  ****  **    **               **     **  **       **          **                                                                ",
    "                                            ***               **     **  **    **   **     **  **       **    **  **    **     **               **    **  **   ***  **   ***  **    **            **     **  **   ***  **   **                **     **  **       **          **                                                                ",
    "                                            * roject           *******   **     **   *******   *******   ******    ******      **               **    **  **    **  **    **  **    **             *******   **    **  ******                  *******   *******  *******  ********                                                             ",
    "                                            *                                                                                                                                                                                                                                                                                                   ",
    "                                        Frank Pilhofer                                                                                                                                                                                                                                                                                          ",
  };
  static char temp[51];
  WINDOW *win, *sub;
  PANEL  *pan, *spa;
  int xpos, delay=20000, i, y;

  if ((win = newwin (12, 54, 10, 13)) == NULL)
    return;
  if ((sub = subwin (win, 10, 50, 11, 15)) == NULL) {
    delwin (win);
    return;
  }
  if ((pan = new_panel (win)) == NULL) {
    delwin (sub);
    delwin (win);
    return;
  }
  if ((spa = new_panel (sub)) == NULL) {
    del_panel (pan);
    delwin (sub);
    delwin (win);
    return;
  }
  
  wattrset  (win, COLOR_PAIR (3));
  wattrset  (sub, COLOR_PAIR (3));
  wfill     (win);
  wfill     (sub);
  box       (win, 0, 0);

  wattrset  (sub, COLOR_PAIR (5));

  temp[50] = '\0';

  for (xpos=0; xpos < strlen(l[0])-50; xpos++) {
    for (y=0; y<10; y++) {
      memcpy    (temp, l[y]+xpos, 50);
      mvwaddstr (sub, y, 0, temp);
    }
    touchwin     (sub);
    update_panels();
    doupdate     ();
    
    for (i=0; i<delay; i++) {
      y = y-- + 1;
      y = y++ - 1;
    }
  }

  del_panel (pan);
  del_panel (spa);
  delwin    (win);
  delwin    (sub);
}
