/*****************************************************************************
******************************************************************************
*****                                                                    *****
*****     hang.c                                                         *****
*****                   Keine Ahnung was das sein soll --- das naechste  *****
*****                   undokumentierte Feature ...!                     *****
*****                                                                    *****
*****     27.08.93      erstellt                                   FP    *****
*****                                                                    *****
******************************************************************************
*****************************************************************************/

#include <curses.h>

#ifdef NOPANEL
#include <nopanel.h>
#else
#include <panel.h>
#endif

#include <time.h>
#include <ctype.h>
#include <string.h>
#include "resource.h"

extern RESOURCE *mainres;

char *HM_GetText (char *target)
{
  RESOURCE *search, *iter;
  int tries=200, prob=100, magic=49;

 retry:
  search = mainres;

  while (search) {
    if (search->type == RES_MSG)
      if ((rand () % prob) == magic)
	break;
    
    if (rand() % 2)
      search = search->LEFT;
    else
      search = search->RIGHT;
  }
  if (search) {
    if (strlen (search->data.msg->text) < 50)
      strcpy (target, search->data.msg->text);
    else {
      memcpy (target, search->data.msg->text, 50);
      target[50] = '\0';
    }
  }
  else if (--tries)
    goto retry;
  else
    strcpy (target, "Dies ist ein Spiel (W) by Frank Pilhofer");
  
  return target;
}

char *HM_PrepareString (char *target, char *source)
{
  while (*source) {
    if (isalpha (*source)) {
      *target++ = '?';
      source++;
    }
    else
      *target++ = *source++;
  }
  *target = '\0';
}

int HM_GuessChar (char *target, char *source, char guess)
{
  int anzahl = 0;

  guess = tolower (guess);

  while (*source) {
    if (*source == guess || *source == toupper (guess)) {
      *target = *source;
      anzahl++;
    }
    target++;
    source++;
  }
  return anzahl;
}

void SpielHangMan (void)
{
  char word[80], guess[80], *ptr;
  FINFO *haupt, *buch;
  int res;

  if ((HM_GetText (word)) == NULL) {
    InfoUser (GetMsgResource ("Sorry"), GetMsgResource ("HMNotPossible"));
    return;
  }
  HM_PrepareString (guess, word);

  if ((haupt = InitForm ("HangMan")) == NULL)
    return;
  else
    DisplayForm (haupt);

  if ((buch = InitForm ("HMGetChar")) == NULL) {
    DeleteForm (haupt);
    return;
  }
  else
    DisplayForm (buch);

  SetHelpContext ("HMGetChar");

  while (1) {
    PutForm (haupt, 300, guess);
    res = InputChar ();

    if (res == KEY_F(0) || res == 0x1b || res == CTRL('X'))
      break;
    if (res > KEY_MIN)
      continue;

    HM_GuessChar (guess, word, (char) res);

    ptr=guess;
    while (*ptr && *ptr!='?')
      ptr++;
    if (*ptr!='?')
      break;
  }
  
  DelHelpContext ();

  ptr=guess;
  while (*ptr && *ptr!='?')
    ptr++;
  if (*ptr!='?')
    InfoUser (GetMsgResource ("Prima"), GetMsgResource ("YouWon"));

  DeleteForm (haupt);
  DeleteForm (buch);
}

void HangMan (void)
{
  int res;

  do {
    SpielHangMan ();
    res = DoSbox ("GambleAgain");
  }
  while (res == 300);
}


