
#include <curses.h>
#include "nopanel.h"

PANEL *ptop = NULL, *ptail = NULL;

PANEL *new_panel (WINDOW *win)
{
    PANEL *temp;

    if ((temp = (PANEL *) malloc (sizeof (PANEL))) == NULL)
        return NULL;

    temp->win     = win;
    temp->visible = TRUE;
    temp->above   = NULL;

    if (ptop == NULL) {
        ptop  = temp;
        ptail = temp;

        temp->below = NULL;
        }
    else {
        temp->below = ptop;
        ptop->above = temp;
        ptop        = temp;
        }

    return temp;
}

int del_panel (PANEL *pan)
{
    if (pan == NULL)
        return ERR;

    if (pan == ptop)
        ptop = ptop->below;

    if (pan == ptail)
        ptail = ptail->above;

    if (pan->below != NULL)
        pan->below->above = pan->above;

    if (pan->above != NULL)
        pan->above->below = pan->below;

    free (pan);

    return OK;
}

int top_panel (PANEL *pan)
{
    if (pan == NULL)
        return ERR;
    if (pan == ptop)
        return OK;

    if (pan == ptail)
        ptail = ptail->above;

    if (pan->above != NULL)
        pan->above->below = pan->below;

    if (pan->below != NULL)
        pan->below->above = pan->above;

    pan->above = NULL;
    pan->below = ptop;

    ptop = pan;

    return OK;
}

int bottom_panel (PANEL *pan)
{
    if (pan == NULL)
        return ERR;
    if (pan == ptail)
        return OK;

    if (pan == ptop)
        ptop = ptop->below;

    if (pan->above != NULL)
        pan->above->below = pan->below;

    if (pan->below != NULL)
        pan->below->above = pan->above;

    pan->below = NULL;
    pan->above = ptail;

    ptail = pan;

    return OK;
}


void update_panels (void)
{
    PANEL *iter = ptail;

    touchwin     (stdscr);
    wnoutrefresh (stdscr);

    while (iter != NULL) {
        if (iter->visible) {
            touchwin     (iter->win);
            wnoutrefresh (iter->win);
            }

        iter = iter->above;
        }
}
