
#ifndef _PANEL_H_
#define _PANEL_H_


typedef struct _panel
	{
                int visible;

		WINDOW	*win;
		struct _panel	*below, *above;

		char	*user;
	} PANEL;


extern PANEL *new_panel     ();
extern int    del_panel     ();
extern int    top_panel     ();
extern int    bottom_panel  ();
extern void   update_panels ();
extern PANEL *ptop, *ptail;


#define hide_panel(p)           ((p)->visible=FALSE)
#define show_panel(p)           ((p)->visible=TRUE)
#define replace_panel(p,w)      ((p)->win=(w))
#define panel_window(p)         ((p)->win)
#define set_panel_userptr(p,c)  ((p)->user=(c))
#define panel_userptr(p)        ((p)->user)
#define panel_above(p)          ((p)?((p)->above):ptail)
#define panel_below(p)          ((p)?((p)->below):ptop)
#define move_panel(p,y,x)       (wmove((p)->win,y,x))
#define panel_hidden(p)         (!((p)->visible))

#endif
